DP.Administration/Controllers/OfferController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using DP.Administration.Models;
using DP.Common.Enums;
using DP.Common.Models;
using DP.Common.Utilities;
using DP.Services.Business;
using DP.Services.Business.Administration;
using DP.Services.Data.Models;

namespace DP.Administration.Controllers
{
    public class OfferController : BaseController
    {
        private OfferManager offerManager;
        public OfferController( OfferManager offerManager)
        {
            this.offerManager = offerManager;
        }
        // GET: Offer
        public ActionResult Index()
        {
            List<OfferMaster> offers = this.offerManager.Get();
            return View(offers);
        }

        // GET: Create
        public ActionResult Create()
        {
            return View();
        }

        // GET: Offer/Details/5
        public ActionResult Details(int id)
        {
            return View();
        }

        // GET: Offer/Details/5
        public ActionResult Subscribers()
        {  
            return PartialView("_Subscribers", this.offerManager.Subscribers());
        }

        // POST: Offer/Create
        [HttpPost]
        [ValidateInput(false)]
        public ActionResult Create(OfferMaster model,HtmlHelper content)
        {
            try
            {
                model.OfferStatusValue = (int)OfferStatus.Active;
                var item =  this.offerManager.Add(model);
                return JsonResult(item);
            }
            catch(Exception ex)
            {
                return View("../Shared/_ViewError", new { Message = ex.Message });
            }
        }
    }
}

DP.Administration/Controllers/api/OfferController.cs
using DP.Common.Utilities;
using DP.Services.Business.Administration;
using DP.Services.Data.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Threading.Tasks;
using System.Web.Http;

namespace DP.Administration.Controllers.Api
{
    public class OfferController : BaseApiController
    {
        private OfferManager offerManager;
        public OfferController(OfferManager offerManager)
        {
            this.offerManager = offerManager;
        }

        [HttpPost]
        public async Task<IHttpActionResult> UploadLogo()
        {   
            if (!Request.Content.IsMimeMultipartContent())
            {
                return InternalServerError(new HttpResponseException(HttpStatusCode.UnsupportedMediaType));
            }

            var dataDictionary = await base.ParseEncodedForm(Request);

            if (dataDictionary != null)
            {
                AwsS3Manager s3Manager = new AwsS3Manager();
                OfferMaster offerMaster = this.offerManager.GetById(Convert.ToInt32(dataDictionary["id"]));
                string fileName = "offerid_" + offerMaster.Id.ToString() + "_eid" + offerMaster.ProviderId.ToString() + "_etype" + offerMaster.ProviderType.ToString() + Convert.ToString(dataDictionary["fileType"]);
                await s3Manager.Upload2Async(dataDictionary["file"] as byte[], fileName, true);

                string url = s3Manager.GetS3Url(fileName);
                offerMaster.ImageUrl = url;
                this.offerManager.Update(offerMaster);
                return Ok(true);
            }

            return BadRequest("Unable to upload image. Try again.");
        }
    }
}

DP.Administration/Views/Offer/Create.cshtml
@{
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<script type="text/javascript" src="~/Scripts/modules/offer.js"></script>
<script src="~/Scripts/ckeditor/ckeditor.js"></script>
<script src="~/Scripts/ckeditor/adapters/jquery.js"></script>
<div class="row">
    <div class="col-lg-12">
        <h1 class="page-header">Offers</h1>
    </div>
    <!-- /.col-lg-12 -->
</div>
<div class="row">
    <div class="col-md-12 col-sm-12">
        <div class="panel panel-default">
            <div class="panel-heading">
                <i class="fa fa-tags fa-fw"></i> Create Offer
            </div>
            <!-- /.panel-heading -->
            <div class="panel-body">
                <form class="form-create-offer" role="form">
                    <div class="form-group">
                        <label for="providerId">Select Provider</label>
                        <select class="form-control" id="ddl-providers" name="providerId">
                            @Html.Action("Subscribers", "Offer");
                        </select>
                    </div>
                    <div class="form-group">
                        <label for="providerEmail">Provider Email</label>
                        <input type="email" class="form-control" placeholder="Email" name="providerEmail" />
                    </div>



                    <div class="form-group">
                        <label for="content">Offer Content</label>
                        @*@Html.TextArea("Content", new { @id = "editor1" })*@
                       
                            @Html.TextArea("Content", new { @class="input-block-level", rows = "5" })
                            <script type="text/javascript">

                                CKEDITOR.replace('Content', { filebrowserImageBrowseUrl: '../../../ckeditor/ImageBrowser.aspx', height: '400px' });
                            </script>
                      
                      
                        </div>




                    <div class="form-group">
                        <label for="offerContent">Validity</label>
                        <div class="row">
                            <div class="col-md-4 col-sm-8">
                                <div class="col-md-6 col-sm-6">
                                    <div class="input-group">
                                        <input type="text" class="form-control datepicker" name="startDateTime" value='' placeholder="Select start date" aria-describedby="basic-addon2">
                                        <span class="input-group-addon"><i class="fa fa-calendar"></i></span>
                                    </div>
                                </div>
                                <div class="col-md-6 col-sm-6">
                                    <div class="input-group">
                                        <input type="text" class="form-control datepicker" name="endDateTime" value='' placeholder="Select expiry date" aria-describedby="basic-addon2">
                                        <span class="input-group-addon"><i class="fa fa-calendar"></i></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="form-group">
                        <div class="row">
                            <div class="col-md-3">
                                <label for="currentPrice">Current Price</label>
                                <div class="input-group">
                                    <input type="text" class="form-control" name="currentPrice" id="txtCurrentPrice" placeholder="Current Price" aria-describedby="basic-addon2">
                                    <span class="input-group-addon">.00</span>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <label for="discountedPercentage">Discount Percentage</label>
                                <div class="input-group">
                                    <input type="text" id="txtDiscount" class="form-control" name="discountedPercentage" placeholder="Discount Percentage" aria-describedby="basic-addon2">
                                    <span class="input-group-addon">%</span>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <label for="actualPrice">Net Price</label><br>
                                <input type="text" class="label label-default" name="actualPrice" id="lblNetPrice" style="font-size:18px;border:none;display:block" readonly="readonly" value="0.0" />
                            </div>
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="quantity">Quantity</label>
                        <div class="input-group">
                            <span class="input-group-addon"><i class="fa fa-users"></i></span>
                            <input type="text" class="form-control" name="quantity" placeholder="Quantity" aria-describedby="basic-addon2">
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="image">Image</label>
                        <div class="fileinput fileinput-new" data-provides="fileinput" id="file-upload-container">
                            <span class="btn btn-xs btn-default btn-file">
                                <input type="file"name="file" />
                                <img class="image-file" style="display:none" />
                            </span>
                        </div>
                    </div>

                    <div class="progress" style="display:none">
                        <div class="progress-bar progress-bar-info progress-bar-striped active" role="progressbar" aria-valuemin="0" aria-valuemax="100" style="width: 40%">
                            <span class="sr-only">40% Complete (success)</span>
                        </div>
                    </div>
                    <a class="btn btn-primary pull-right btn-create-offer">Save</a>
                </form>
            </div>
            <!-- /.panel-body -->
        </div>
    </div>
</div>

DP.Administration/Views/Offer/Details.cshtml
@{
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<div class="row">
    <div class="col-lg-12">
        <h1 class="page-header">Offers</h1>
    </div>
    <!-- /.col-lg-12 -->
</div>
<div class="row">
    <div class="col-md-12 col-sm-12">
        <div class="panel panel-default">
            <div class="panel-heading">
                <i class="fa fa-tags fa-fw"></i>Offer Details
            </div>
            <!-- /.panel-heading -->
            <div class="panel-body">
                <form class="form-create-offer" role="form">
                    <div class="form-group">
                        <label for="providerId">Select Provider</label>
                        <select class="form-control" id="ddl-providers" name="providerId">
                            @Html.Action("Subscribers", "Offer");
                        </select>
                    </div>
                    <div class="form-group">
                        <label for="providerEmail">Provider Email</label>
                        <input type="email" class="form-control" placeholder="Email" name="providerEmail" />
                    </div>
                    <div class="form-group">
                        <label for="content">Offer Content</label>
                        <input type="text" class="form-control" name="content" placeholder="Description" name="offerContent" />
                    </div>
                    <div class="form-group">
                        <label for="offerContent">Validity</label>
                        <div class="row">
                            <div class="col-md-4 col-sm-8">
                                <div class="col-md-6 col-sm-6">
                                    <div class="input-group">
                                        <input type="text" class="form-control datepicker" name="startDateTime" value='' placeholder="Select start date" aria-describedby="basic-addon2">
                                        <span class="input-group-addon"><i class="fa fa-calendar"></i></span>
                                    </div>
                                </div>
                                <div class="col-md-6 col-sm-6">
                                    <div class="input-group">
                                        <input type="text" class="form-control datepicker" name="endDateTime" value='' placeholder="Select expiry date" aria-describedby="basic-addon2">
                                        <span class="input-group-addon"><i class="fa fa-calendar"></i></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="form-group">
                        <div class="row">
                            <div class="col-md-3">
                                <label for="currentPrice">Current Price</label>
                                <div class="input-group">
                                    <input type="text" class="form-control" name="currentPrice" id="txtCurrentPrice" placeholder="Current Price" aria-describedby="basic-addon2">
                                    <span class="input-group-addon">.00</span>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <label for="discountedPercentage">Discount Percentage</label>
                                <div class="input-group">
                                    <input type="text" id="txtDiscount" class="form-control" name="discountedPercentage" placeholder="Discount Percentage" aria-describedby="basic-addon2">
                                    <span class="input-group-addon">%</span>
                                </div>
                            </div>
                            <div class="col-md-3">
                                <label for="actualPrice">Net Price</label><br>
                                <input type="text" class="label label-default" name="actualPrice" id="lblNetPrice" style="font-size:18px;border:none;display:block" readonly="readonly" value="0.0" />
                            </div>
                        </div>
                    </div>
                    @*<div class="form-group">
                            <label for="image">Image</label>
                            <div class="fileinput fileinput-new" data-provides="fileinput">
                                <span class="btn btn-xs btn-default btn-file"><input type="file" /></span>
                            </div>
                        </div>*@
                    <div class="form-group">
                        <label for="quantity">Quantity</label>
                        <div class="input-group">
                            <span class="input-group-addon"><i class="fa fa-users"></i></span>
                            <input type="text" class="form-control" name="quantity" placeholder="Quantity" aria-describedby="basic-addon2">
                        </div>
                    </div>
                    <a class="btn btn-primary pull-right btn-create-offer">Save</a>
                </form>
            </div>
            <!-- /.panel-body -->
        </div>
    </div>
</div>
<script type="text/javascript" src="~/Scripts/modules/offer.js"></script>

DP.Administration/Views/Offer/Index.cshtml
@{
    Layout = "~/Views/Shared/_Layout.cshtml";
}
@using DP.Services.Data.Models
@using DP.Common.Enums
@model List<OfferMaster>
@{ 
    var activeOffers = Model.Where(x => x.OfferStatusValue == (int)OfferStatus.Active).ToList();
    var deactiveOffers = Model.Where(x => x.OfferStatusValue == (int)OfferStatus.Deactive).ToList();
}
<div class="row">
    <div class="col-lg-12">
        <h1 class="page-header">Offers</h1>
    </div>
    <!-- /.col-lg-12 -->
</div>
<div class="row">
    <div class="col-md-12 col-sm-12">
        <div class="panel panel-default">
            <div class="panel-heading">
                <i class="fa fa-tags fa-fw"></i> List
                <div class="pull-right">
                    <a href="/Offer/Create" class="btn btn-default btn-xs"><i class="fa fa-plus fa-fw"></i> Create</a>
                </div>
            </div>
            <!-- /.panel-heading -->
            <div class="panel-body">
                <ul class="nav nav-pills nav-justified" role="tablist">
                    <li class="active">
                        <a href="#active-offers" role="tab" data-toggle="tab">Active Offers
                        </a>
                    </li>
                    <li class="">
                        <a href="#deactive-offers" role="tab" data-toggle="tab">
                            Deactive Offers
                        </a>
                    </li>
                </ul>
                <div class="tab-content">
                    <div class="tab-pane fade active in" role="tabpanel" id="active-offers" style="padding-top: 15px;">

                        @foreach (var m in activeOffers)
                        {
                            <div class="col-md-6 subscriber-panel-item ">
                                <div class="panel panel-default panel-subscriber panel-offer">
                                    <div class="panel-body">
                                        <div class="row">
                                            <div class="col-md-8">
                                                <h4>@m.ProviderName</h4>
                                                <h5>@m.Content</h5>
                                                <h5>@m.ProviderEmail</h5>
                                            </div>
                                            <div class="col-md-4 image-col">
                                                @if (m.OfferStatusValue == (int)OfferStatus.Active)
                                                {
                                                    <i class="fa fa-tags fa-lg green-glow featured"></i>
                                                }
                                                else
                                                {
                                                    <i class="fa fa-tags fa-lg red-glow featured"></i>
                                                }
                                                <span class="label label-default" id="lblNetPrice" style="font-size:18px;border:none;display:block">@m.ActualPrice</span>
                                                <img src="@m.ImageUrl" style="height:100px;width:100%;">
                                            </div>
                                        </div>
                                        <div class="row details">
                                            <div class="col-md-6">
                                                <table>
                                                    <tr>
                                                        <td>User Type</td>
                                                        <td class="padder"></td>
                                                        <td>@m.ProviderTypeText</td>
                                                    </tr>
                                                    <tr>
                                                        <td>Current Price</td>
                                                        <td class="padder"></td>
                                                        <td>@m.CurrentPrice</td>
                                                    </tr>
                                                    <tr>
                                                        <td>Discounted Percetage</td>
                                                        <td></td>
                                                        <td>@m.DiscountedPercentage</td>
                                                    </tr>
                                                </table>
                                            </div>
                                            <div class="col-md-6">
                                                <table cellpadding="2">
                                                    <tr>
                                                        <td>Start Date</td>
                                                        <td class="padder"></td>
                                                        <td>
                                                            <span>@m.StartDateTime.Value.ToString("dd-MMM-yyyy")</span>
                                                        </td>
                                                    </tr>
                                                    <tr>
                                                        <td>End Date</td>
                                                        <td class="padder"></td>
                                                        <td>
                                                            <span>@m.EndDateTime.Value.ToString("dd-MMM-yyyy")</span>
                                                        </td>
                                                    </tr>
                                                </table>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        }
                    </div>
                    <div class="tab-pane fade" role="tabpanel" id="deactive-offers" style="padding-top: 15px;">
                        @foreach (var m in deactiveOffers)
                        {
                            <div class="col-md-6 subscriber-panel-item ">
                                <div class="panel panel-default panel-subscriber panel-offer">
                                    <div class="panel-body">
                                        <div class="row">
                                            <div class="col-md-8">
                                                <h4>@m.ProviderName</h4>
                                                <h5>@m.Content</h5>
                                                <h5>@m.ProviderEmail</h5>
                                            </div>
                                            <div class="col-md-4 image-col">
                                                @if (m.OfferStatusValue == (int)OfferStatus.Active)
                                                {
                                                    <i class="fa fa-tags fa-lg green-glow featured"></i>
                                                }
                                                else
                                                {
                                                    <i class="fa fa-tags fa-lg red-glow featured"></i>
                                                }
                                                <span class="label label-default" id="lblNetPrice" style="font-size:18px;border:none;display:block">@m.ActualPrice</span>
                                                <img src="@m.ImageUrl" style="height:100px;width:100%;">
                                            </div>
                                        </div>
                                        <div class="row details">
                                            <div class="col-md-6">
                                                <table>
                                                    <tr>
                                                        <td>User Type</td>
                                                        <td class="padder"></td>
                                                        <td>@m.ProviderTypeText</td>
                                                    </tr>
                                                    <tr>
                                                        <td>Current Price</td>
                                                        <td class="padder"></td>
                                                        <td>@m.CurrentPrice</td>
                                                    </tr>
                                                    <tr>
                                                        <td>Discounted Percetage</td>
                                                        <td></td>
                                                        <td>@m.DiscountedPercentage</td>
                                                    </tr>
                                                </table>
                                            </div>
                                            <div class="col-md-6">
                                                <table cellpadding="2">
                                                    <tr>
                                                        <td>Start Date</td>
                                                        <td class="padder"></td>
                                                        <td>
                                                            <span>@m.StartDateTime.Value.ToString("dd-MMM-yyyy")</span>
                                                        </td>
                                                    </tr>
                                                    <tr>
                                                        <td>End Date</td>
                                                        <td class="padder"></td>
                                                        <td>
                                                            <span>@m.EndDateTime.Value.ToString("dd-MMM-yyyy")</span>
                                                        </td>
                                                    </tr>
                                                </table>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        }
                    </div>
                </div>

            </div>
            <!-- /.panel-body -->
        </div>
    </div>
</div>

<style>
    .nav.nav-tabs.nav-justified li a.active{
       background-color: #1f4e5f;
       color: white;
    }
</style>

DP.Administration/Views/Offer/_Subscribers.cshtml
@model List<DP.Common.Models.FeaturedEntity>
@using DP.Common.Utilities;
@using DP.Common.Enums;
@{ 
  int _userType = 0;
}
@foreach(var fe in Model)
{
    _userType = (int)EnumHelper<UserType>.GetValueFromDescription(fe.Type);
    <option data-user-type="@_userType" value="@fe.Id">@fe.Name (@fe.Type)</option>
}